#include <stdio.h>
#include <stdlib.h>

void transmit(int N, int S, int D[]);
void send(int L, int F[], int R[]);

void receive(int N, int S, int L, int D[]);
void answer(int V[]);

typedef void (*transmitFunction)(int N, int K, int D[]);
typedef void (*receiveFunction)(int N, int S, int L, int D[]);

namespace grader {
    static const int MAXN = 100000;
    static const int MAXS = 100;
    static const int MAX_SEND = 100;
    static const int MAX_SUM_L = 1000000;

    static int D[MAXN];
    static int DP[MAXN];

    static int V[MAXN];
    static int DecD[MAXN];

    static int E[MAXS];

    static int cur;
    static int curError;
    static int sumL;
    static int N, S;
    static int sendCalls;

    void send(int L, int F[], int R[]) {
        if (L < 1 || L > MAX_SUM_L) {
            printf("1\nWrong number of bits sent: %d\n", L);
            exit(92);
        }
        sumL += L;
        if (sumL > MAX_SUM_L) {
            printf("1\nToo many bits sent: %d\n", sumL);
            exit(92);
        }
        sendCalls++;
        if (sendCalls > MAX_SEND) {
            printf("1\nToo many calls of send: %d\n", sendCalls);
            exit(92);
        }

        for (int i = 0; i < L; i++) {
            if (F[i] != 0 && F[i] != 1) {
                printf("1\nInvalid bit sent: %d\n", F[i]);
                exit(92);
            }
            while (curError < S && E[curError] < cur) {
                curError++;
            }
            if (curError < S && E[curError] == cur) {
                R[i] = 1 - F[i];
            } else {
                R[i] = F[i];
            }
            V[cur] = R[i];
            cur++;
        }
    }

    void answer(int A[]) {
        for (int i = 0; i < N; i++) {
            if (A[i] != D[i]) {
                printf("1\nWrong decoded bit %d - expected %d, found %d\n", i, D[i], A[i]);
                exit(92);
            }
        }
        printf("0\nDecoded correctly\n");
        exit(0);
    }

    int _main(transmitFunction transmit, receiveFunction receive)
    {
        scanf("%d", &N);
        for (int i = 0; i < N; i++) {
            int u;
            scanf("%d", &u);
            D[i] = DP[i] = u;
        }
        scanf("%d", &S);
        for (int i = 0; i < S; i++) {
            scanf("%d", &E[i]);
        }

        cur = 0;
        curError = 0;
        sendCalls = 0;
        transmit(N, S, DP);

        receive(N, S, sumL, V);

        return 0;
    }
}

void send(int L, int F[], int R[]) {
    grader::send(L, F, R);
}

void answer(int A[]) {
    grader::answer(A);
}

int main() {
    return grader::_main(transmit, receive);
}
